<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/print_concepts.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">print_concepts.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="print__concepts_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (c) 2021 Martin B. Krauss.</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// Licensed under the MIT LICENSE.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// See the file &#39;LICENSE&#39; that should be distributed with this software or can</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// be found at &#39;https://gitlab.com/martin.b.krauss/cpp20-print&#39; for details.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef CPP20PRINT_PRINT_CONCEPTS_H</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define CPP20PRINT_PRINT_CONCEPTS_H</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;concepts&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;filesystem&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">namespace </span>cpp20print::concepts {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#a7be037f25d3aca35ec2ab298e4fe0e4e">   22</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#a7be037f25d3aca35ec2ab298e4fe0e4e">Printable</a> = requires(T t) {</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    {std::cout &lt;&lt; t} -&gt; std::same_as&lt;std::ostream&amp;&gt;;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;};</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; </div>
<div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#a0dc42e855b90ebe331eadf76da1ed24a">   30</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#a0dc42e855b90ebe331eadf76da1ed24a">PrintableList</a> = requires (T a) {</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        {a.begin()} -&gt; std::forward_iterator;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    };</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; </div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#acfda3fade5c38f41048c0dd4e65f8fe0">   39</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#acfda3fade5c38f41048c0dd4e65f8fe0">HasLastElement</a> = requires (T a) {</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        {a.end()} -&gt; std::bidirectional_iterator;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    };</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; </div>
<div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#a0b5fd4e23b5ae4ce823b0e118efa4891">   46</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#a0b5fd4e23b5ae4ce823b0e118efa4891">PrintablePair</a> = requires (T a) {</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        {a.first};</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        {a.second};</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    };</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#ae27a2f21813c49002cf57d13f790652e">   53</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#ae27a2f21813c49002cf57d13f790652e">PrintableInteger</a> = </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    std::integral&lt;T&gt; &amp;&amp;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    std::same_as&lt;char, T&gt; == <span class="keyword">false</span>;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#a7a2d86af06580c5b0986709822bb471e">   59</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#a7a2d86af06580c5b0986709822bb471e">PrintableFloat</a> = std::floating_point&lt;T&gt;;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#a6151497910d0d5171a62aed06bf06f35">   63</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#a6151497910d0d5171a62aed06bf06f35">HasStringMethod</a> = requires(T t) {</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    {t.string()} -&gt; std::same_as&lt;std::string&gt;;    </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;};</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#a44633268b78ebac99b47279732528c32">   69</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#a44633268b78ebac99b47279732528c32">UnicodeString</a> =</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    std::same_as&lt;T, std::u8string&gt; ||</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    std::same_as&lt;T, std::u16string&gt; ||</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    std::same_as&lt;T, std::u32string&gt;;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#ab6a1189eb9b1269caae54f7ab7983c93">   76</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#ab6a1189eb9b1269caae54f7ab7983c93">StdPrintable</a> = requires (T t) {</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    {std::operator&lt;&lt;(std::cout, t)} -&gt; std::same_as&lt;std::ostream&amp;&gt;;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;};</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="print__concepts_8h.html#a98cd10e7572b303706baeb59ab097a3e">   83</a></span>&#160;concept <a class="code" href="print__concepts_8h.html#a98cd10e7572b303706baeb59ab097a3e">DefaultPrintable</a> = </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        StdPrintable&lt;T&gt; ||</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        std::same_as&lt;T, std::filesystem::path&gt;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        ;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;}</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aprint__concepts_8h_html_a98cd10e7572b303706baeb59ab097a3e"><div class="ttname"><a href="print__concepts_8h.html#a98cd10e7572b303706baeb59ab097a3e">cpp20print::concepts::DefaultPrintable</a></div><div class="ttdeci">concept DefaultPrintable</div><div class="ttdoc">Objects that are printable by default.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:83</div></div>
<div class="ttc" id="aprint__concepts_8h_html_a0dc42e855b90ebe331eadf76da1ed24a"><div class="ttname"><a href="print__concepts_8h.html#a0dc42e855b90ebe331eadf76da1ed24a">cpp20print::concepts::PrintableList</a></div><div class="ttdeci">concept PrintableList</div><div class="ttdoc">Objects that can be printed as a list.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:30</div></div>
<div class="ttc" id="aprint__concepts_8h_html_ab6a1189eb9b1269caae54f7ab7983c93"><div class="ttname"><a href="print__concepts_8h.html#ab6a1189eb9b1269caae54f7ab7983c93">cpp20print::concepts::StdPrintable</a></div><div class="ttdeci">concept StdPrintable</div><div class="ttdoc">Objects that are printable in the std namespace.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:76</div></div>
<div class="ttc" id="aprint__concepts_8h_html_a6151497910d0d5171a62aed06bf06f35"><div class="ttname"><a href="print__concepts_8h.html#a6151497910d0d5171a62aed06bf06f35">cpp20print::concepts::HasStringMethod</a></div><div class="ttdeci">concept HasStringMethod</div><div class="ttdoc">Objects with a string() method.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:63</div></div>
<div class="ttc" id="aprint__concepts_8h_html_a7a2d86af06580c5b0986709822bb471e"><div class="ttname"><a href="print__concepts_8h.html#a7a2d86af06580c5b0986709822bb471e">cpp20print::concepts::PrintableFloat</a></div><div class="ttdeci">concept PrintableFloat</div><div class="ttdoc">Floating point numbers.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:59</div></div>
<div class="ttc" id="aprint__concepts_8h_html_a0b5fd4e23b5ae4ce823b0e118efa4891"><div class="ttname"><a href="print__concepts_8h.html#a0b5fd4e23b5ae4ce823b0e118efa4891">cpp20print::concepts::PrintablePair</a></div><div class="ttdeci">concept PrintablePair</div><div class="ttdoc">Objects that have a first and second member.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:46</div></div>
<div class="ttc" id="aprint__concepts_8h_html_acfda3fade5c38f41048c0dd4e65f8fe0"><div class="ttname"><a href="print__concepts_8h.html#acfda3fade5c38f41048c0dd4e65f8fe0">cpp20print::concepts::HasLastElement</a></div><div class="ttdeci">concept HasLastElement</div><div class="ttdoc">Lists that have a defined last element.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:39</div></div>
<div class="ttc" id="aprint__concepts_8h_html_ae27a2f21813c49002cf57d13f790652e"><div class="ttname"><a href="print__concepts_8h.html#ae27a2f21813c49002cf57d13f790652e">cpp20print::concepts::PrintableInteger</a></div><div class="ttdeci">concept PrintableInteger</div><div class="ttdoc">Integers but not a char.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:53</div></div>
<div class="ttc" id="aprint__concepts_8h_html_a7be037f25d3aca35ec2ab298e4fe0e4e"><div class="ttname"><a href="print__concepts_8h.html#a7be037f25d3aca35ec2ab298e4fe0e4e">cpp20print::concepts::Printable</a></div><div class="ttdeci">concept Printable</div><div class="ttdoc">Objects that can be printed to a std::ostream.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:22</div></div>
<div class="ttc" id="aprint__concepts_8h_html_a44633268b78ebac99b47279732528c32"><div class="ttname"><a href="print__concepts_8h.html#a44633268b78ebac99b47279732528c32">cpp20print::concepts::UnicodeString</a></div><div class="ttdeci">concept UnicodeString</div><div class="ttdoc">Unicode strings.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:69</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
